// code.9leap.net default template
// based on enchant.js v0.7.1
enchant();

enchant.nineleap.memory.LocalStorage.GAME_ID = 3474;
enchant.nineleap.memory.LocalStorage.DEBUG_MODE = false;
enchant.nineleap.memory.HttpRequest.SERVER_URL = 'http://9leap.net/api/';

var game = null;
var player = null;
var Blush = false;
var surface = null;
var canvas = null;
var playerImg = null;
var MODE_DRAW = 100;
var MODE_ANSWER = 200;
var mode = MODE_DRAW;
var LIMIT = 17000; //17sec
var themeall = null;
var themedraw = null;
var CANVAS_SIZE = 80;
var CANVAS_SCALE = 4;
var q = null;

MyCanvas = Class.create(Sprite, {
    initialize: function() {
        Sprite.call(this, CANVAS_SIZE, CANVAS_SIZE);
        this.scaleX = this.scaleY = CANVAS_SCALE;
        this.x = 120;
        this.y = 120;
    },
    ontouchstart: function(e) {
        Blush = true;
        this.bx = e.x / this.scaleX;
        this.by = e.y / this.scaleY;
    },
    ontouchend: function(e) {
        Blush = false;
    },
    ontouchmove: function(e) {
        if (Blush) {
            surface.line(e.x / this.scaleX, e.y / this.scaleY, this.bx, this.by);
        }
        this.bx = e.x / this.scaleX;
        this.by = e.y / this.scaleY;
    }
});

DrawMode = Class.create(Group, {
    initialize: function() {
        Group.call(this);
        this.preDate = 0;
        this.t = 0; //past time
    },
    onenterframe: function(e) {
        if (this.preDate == 0) {
            this.preDate = new Date();
        } else {
            var newDate = new Date();
            this.t += newDate - this.preDate;
            this.preDate = newDate;
        }
        if (this.t > LIMIT) {
            //add frame
            n = parseInt(Math.random() * 5 + 1);
            surface.draw(game.assets['g' + n + '.png']);
            //draw image to memory
            var d = surface.toDataURL("image/png");
            //alert(d.length);
            player = game.memory.player;
            if (game.memory.player.data.imgNo == null) {
                game.memory.player.data.imgNo = 0;
            }
            game.memory.player.data.imgNo++;
            game.memory.player.data.img = d;

            game.memory.update();
            game.end();

        }
    }
});


function scorecheck(player, rec) {
    for (i = 0; i < rec.length; i++) {
        if (rec[i].data.answer != null) {
            for (j = 0; j < rec[i].data.answer.length; j++) {
                add = true;
                for (k = 0; k < game.memory.player.data.score.length; k++) {
                    if (rec[i].data.answer[j].imgNo == game.memory.player.data.score[k].imgNo && rec[i].data.answer[j].name == game.memory.player.name) {
                        add = false;
                        break;
                    }
                }
                if (add) {
                    var addScore = {};
                    addScore.imgNo = rec[i].data.answer[j].imgNo;
                    addScore.score = rec[i].data.answer[j].score;
                    addScore.name = rec[i].name;
                    game.memory.player.data.score.push(addScore);
                }
            }
        }
    }
}

window.onload = function() {
    game = new Core(320, 320);
    game.preload('g1.png', 'g2.png', 'g3.png', 'g4.png', 'g5.png', 'bk.png', 'theme.png', 'd.png');
    game.fps = 30;
    game.memory.player.preload();
    try{
        game.memories.recent.preload();
    }catch(e){
    	alert(e);
    }
    try{
	    game.memories.ranking.preload();
    }catch(e){
    	alert(e);
    }	    

    game.onload = function() {
        player = game.memory.player;
        //no player's data
        if (game.memory.player.data == null) {
            game.memory.player.data = {};
            game.memory.player.data.img = '';
            game.memory.player.data.imgNo = 1;
            game.memory.player.data.imganswer = '';
            game.memory.player.data.sum = 0;
            game.memory.player.data.choice = new Array();
            game.memory.player.data.answer = 0;
        } else {
            //player doesn't have picture
            if (game.memory.player.data.img == null || game.memory.player.data.img == '') {
                //draw mode
                mode = MODE_DRAW;
            } else {
			    //player gets points from other players
			    rec=game.memories.recent;
			    rank=game.memories.ranking;
                //answer mode
                mode = MODE_ANSWER;

                //how many answer ?
                if (game.memory.player.data.answer != null) {
                    if (game.memory.player.data.answer > 3) {
                        //send image to server
                        //unimplemented

                        //delete image
                        game.memory.player.data.imgNo++;
                        game.memory.player.data.img = '';
                        game.memory.player.data.imganswer = '';
                        game.memory.player.data.choice = new Array();
                        game.memory.player.data.answer = 0;

                        //draw mode
                        mode = MODE_DRAW;

                    }
                }

            }

        }


        if (mode == MODE_DRAW) {
            //get theme
            themeall = theme[parseInt(Math.random() * theme.length)];
            game.memory.player.data.choice = themeall;
            themedraw = themeall[parseInt(Math.random() * themeall.length)];
            game.memory.player.data.imganswer = themedraw;
            var SceneTheme = new Scene();
            g = new Group();
            s = new Sprite(320, 320);
            s.image = game.assets['theme.png'];
            s.ontouchend = function(e) {
                //draw start
                var SceneDraw = new Scene();
                var stage = new DrawMode();
                canvas = new MyCanvas();
                surface = new enchant.Paint(CANVAS_SIZE, CANVAS_SIZE);
                canvas.image = surface;
                stage.addChild(canvas);
                SceneDraw.addChild(stage);
                game.popScene();
                game.pushScene(SceneDraw);

                //draw mode is end, when time expire in stage.onenterframe
                //when draw mode is end, save draw image to memory
                //then game.end
            };
            g.addChild(s);
            t = new Label(themedraw);
            t.x = 40;
            t.width = 240;
            t.y = 160;
            t.font = "normal normal 16px/1.0 MS PGothic";
            t.color = 'white';
            g.addChild(t);
            SceneTheme.addChild(g);
            game.popScene();
            game.pushScene(SceneTheme);

        } else {
            //answer mode is start, when there is atleast one anyone's image
            if (enchant.nineleap.memory.LocalStorage.DEBUG_MODE == false) {
                quiz = -1;
                count = 0;
                list = new Array();
                while (count < 60) {
                    //recent or rank
                    w = parseInt(Math.random() * 2);
                    if (w == 0) {
                    	count++;
                    	if (typeof(rec) == 'undefined') continue;
                        list = rec;
                    } else {
                    	count++;
                    	if (typeof(rank) == 'undefined') continue;
                        list = rank;
                    }
                    no = parseInt(Math.random() * list.length);
                    if (typeof(list[no]) != 'undefined') {
                        if (list[no].data.img != '' && list[no].name != game.memory.player.name) {
                            quiz = no;
                            break;
                        }
                    }
                    count++;
                }
                if (quiz == -1) {
                    //there is no image for answer
                    alert("まだ回答できるイラストがないです！　また来てね！");
                    game.end();
                }
            } else {
                //debug start
                no = 0;
                list = new Array();
                list[no] = {};
                list[no].data = game.memory.player.data;
                //debug end
            }

            SceneAnswer = new Scene();
            q = new Sprite(CANVAS_SIZE, CANVAS_SIZE);
            q.scaleX = q.scaleY = CANVAS_SCALE;
            q.x = 120;
            q.y = 120;
            q.imgNo = list[no].imgNo;
            q.imganswer = list[no].data.imganswer;
            q.choice = list[no].data.choice;
            playerImg = new Image();
            playerImg.src = list[no].data.img;
            sur = new Surface(CANVAS_SIZE, CANVAS_SIZE);
            var cx = sur.context;
            cx.drawImage(playerImg, 0, 0);
            q.image = sur;
            playerImg.q=q;
            playerImg.onload = function() {
	            sur = new Surface(CANVAS_SIZE, CANVAS_SIZE);
	            var cx = sur.context;
	            cx.drawImage(this, 0, 0);
	            this.q.image = sur;
            };

            q.on('touchend', function(e) {
                c = new Scene();
                d = new Sprite(320, 320);
                d.image = game.assets['d.png'];
                c.addChild(d);
                l = new Label("正解だと思う説明文を選んでください！");
                l.x = 30;
                l.y = 20;
                l.color = 'red';
                c.addChild(l);
                b = {};
                for (i = 0; i < this.choice.length; i++) {
                    b[i] = new Button(this.choice[i], "dark");
                    b[i].width = 260;
                    b[i].height = 48;
                    b[i].x = 20;
                    b[i].y = i * 60 + 60;
                    b[i].opacity = 0.8;
                    b[i].answer = this.imganswer;
                    b[i].ontouchend = function() {
                        if (this.text == this.answer) {
                            //correct!
                            if (typeof(game.memory.player.data.sum) == 'undefined'){
                                game.memory.player.data.sum=0;
                            }
                            game.memory.player.data.sum += 100;
                            if (typeof(game.memory.player.data.answer) == 'undefined'){
                                game.memory.player.data.answer=0;
                            }
                            game.memory.player.data.answer++;
                            game.memory.update();

                            game.end(game.memory.player.data.sum, "正解！　今のお絵かきポイントは" + game.memory.player.data.sum + "です");
                        } else {
                            //incorrect...
                            if (typeof(game.memory.player.data.answer) == 'undefined'){
                                game.memory.player.data.answer=0;
                            }
                            game.memory.player.data.answer++;
                            if (typeof(game.memory.player.data.sum) == 'undefined'){
                                game.memory.player.data.sum=0;
                            }
                            game.memory.update();
                            game.end(game.memory.player.data.sum, "不正解！　今のお絵かきポイントは" + game.memory.player.data.sum + "です");
                        }
                    }
                    c.addChild(b[i]);

                }

                game.popScene();
                game.pushScene(c);
            });
            g = new Group();
            g.addChild(q);
            //explain text
            bk = new Sprite(320, 52);
            bk.y = 5;
            bk.image = game.assets['bk.png'];
            bk.opacity = 0.5;
            g.addChild(bk);
            l1 = new Label("絵をよく見てください。");
            l1.x = 10;
            l1.y = 10;
            l1.color = 'red';
            g.addChild(l1);
            l2 = new Label("分かったら画面をタッチして回答してください。");
            l2.x = 10;
            l2.y = 16 + 10;
            l2.color = 'red';
            g.addChild(l2);
            l3 = new Label("※もし真っ白だったら再読み込みをしてください。");
            l3.x = 10;
            l3.y = 16 * 2 + 10;
            l3.color = 'red';
            g.addChild(l3);
            SceneAnswer.addChild(g);
            game.pushScene(SceneAnswer);
        }

    };
    game.start();
};