//キャンバス拡張
enchant.Paint = enchant.Class.create(enchant.Surface, {
    //色を設定
	color:function(scolor,fcolor){
		if(scolor){this.context.strokeStyle = scolor;}
		if(fcolor){this.context.fillStyle = fcolor;}		
	},
    //線を描く
    line:function(x1,y1,x2,y2){
        this.context.beginPath(); //J コンテキストでパス開始
        this.context.moveTo(x1, y1); //K (x,y)から
        this.context.lineTo(x2, y2); //L (mouseX,mouseY)まで
        this.context.stroke(); //M 直線を引く
    },
	//四角形を描画(x,y)座標から(+xx,+yy)の大きさの四角を作成
	square:function(x,y,xx,yy){
		this.context.beginPath();
        this.context.moveTo(x,y);
        this.context.lineTo(x+xx,y);
        this.context.lineTo(x+xx,y+yy);
        this.context.lineTo(x,y+yy);
        this.context.closePath();
        this.context.stroke();
	},
	//円を描画(x,y)を中心に半径radiusの円を描く
	circle:function(x,y,radius,fill){	
	  this.context.beginPath();
	  this.context.arc(x, y, radius, 0, Math.PI*2, false);
	  this.context.stroke();
	  if(fill == true){
	  	this.context.fill();
	  }
	},
	//扇形を描画(x,y)を中心に半径radiusのSang度からEang度までの扇形を書く。
	circularsector:function(x,y,radius,Sang,Eang,fill){
	  this.context.beginPath();
	  this.context.arc(x, y, radius, Sang * Math.PI/180, Eang *  Math.PI/180);
	  this.context.stroke();
	  this.context.moveTo(Math.cos(Sang * Math.PI/180)*radius+x,Math.sin(Sang * Math.PI/180)*radius+y);
	  this.context.lineTo(x,y);
	  this.context.lineTo(Math.cos(Eang * Math.PI/180)*radius+x,Math.sin(Eang * Math.PI/180)*radius+y);
	  this.context.stroke();
	  if(fill == true){
	  	this.context.fill();
	  }
	},
	//塗りつぶしx,y座標にCOLの色（配列でRGBまたはRGBA）で塗りつぶす。
	seedfill:function(x,y,col){
		this.cvs = this.context.getImageData(0,0,this.width,this.height);
		var base_color = this.colorcode(x,y,true);
		var buff = [];
		buff.push([x,y]);
		var lx=x;
		var rx=x;
		var py=y;
		if(col[3] == null){col[3]=255;}
		this.cnt = 0;
		//左端を到達
		while(buff[0] != null){
			while(buff[0][0]-1 >= 0 && base_color == this.colorcode(buff[0][0]-1,buff[0][1],true)){
				buff[0][0]--;
			}
			rx = buff[0][0];
			var topflag=false;
			var btmflag=false;
			while(rx < this.width && base_color == this.colorcode(rx,buff[0][1],true)){
				this.cvs.data[buff[0][1]*this.width*4+rx*4]   = col[0];
				this.cvs.data[buff[0][1]*this.width*4+rx*4+1] = col[1];
				this.cvs.data[buff[0][1]*this.width*4+rx*4+2] = col[2];
				this.cvs.data[buff[0][1]*this.width*4+rx*4+3] = col[3];
				
				if(buff[0][1] -1 >= 0 && base_color == this.colorcode(rx,buff[0][1]-1,true) && topflag==false){
					buff.push([rx,buff[0][1]-1]);
					this.cnt++;
					topflag=true;
				}else{
					if(base_color != this.colorcode(rx,buff[0][1]-1,true)){topflag = false;}
				}
				if(buff[0][1] +1 < this.height && base_color == this.colorcode(rx,buff[0][1]+1,true) && btmflag==false){
					buff.push([rx,buff[0][1]+1]);
					this.cnt++;
					btmflag=true;
				}else{				
					if(base_color != this.colorcode(rx,buff[0][1]+1,true)){btmflag = false;}
				}
				rx++;
			}
			buff.shift();

		}
		this.context.putImageData(this.cvs,0,0);
		this.cvs = false;
	},
	//指定したセルの色を取得(x,y)座標　alpha==trueの場合alpha値も。ary==trueの場合配列で返す。
	colorcode:function(x,y,alpha,ary){
		if(this.cvs){
		  var col = [];
		  col.data = [this.cvs.data[y*this.width*4+x*4],this.cvs.data[y*this.width*4+x*4+1],this.cvs.data[y*this.width*4+x*4+2],this.cvs.data[y*this.width*4+x*4+3]];
		}else{
		 var col = this.context.getImageData(x,y,1,1);
		 this.cvs = false;
	   	}
	   	
	   	if(ary){return col.data}
	   	if(alpha){
	   		return "rgba(" + col.data[0] + "," + col.data[1] + "," + col.data[2] + "," + col.data[3]/255 + ")";
	   	}else{
		  	return "rgb(" + col.data[0] + "," + col.data[1] + "," + col.data[2] + ")";
	   	}
	}
	
});